#ifndef MENUP_H
#define MENUP_H

/*--------------------------------------------------------------------.
| menuP.h                                                             |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

# define VERSION "1.05"

typedef struct
{
   unsigned short attr;
   short info;
   void *ptr;
} MENUP;

typedef struct
{
   unsigned short attr;
   short info;
   unsigned long *x;
} MENUL;

typedef struct
{
   MENUP   mennm;
   MENUP   defnm;
   MENUP   dirnm;
   MENUP   extnm;
   long    size;
   long    xpos;
   long    ypos;
   long    mainc;
   long    filec;
   MENUP   fname;
} MENUFSEL;

typedef struct
{
   MENUP   mennm;
   long    lines;
   long    xpos;
   long    ypos;
   long    mainc;
   long    ddirc;
   MENUP   fname;
} MENUDSEL;

typedef struct
{
   long    xpos;
   long    ypos;
   long    mainc;
   MENUP   fname;
} MENUXSEL;

typedef struct
{
   MENUP mennm;
   MENUP prmpt;
   MENUP item1;
   MENUP item2;
   MENUP item3;
   long xpos;
   long ypos;
   long mainc;
   MENUP retn;
} MENUITSL;

typedef struct
{
   long error;
   long xpos;
   long ypos;
   long mainc;
} MENURPER;

typedef struct
{
   long error;
   long optns;
   long xpos;
   long ypos;
   long mainc;
   MENUP actn;
} MENUFERR;

typedef struct
{
   MENUP mennm;
   MENUP defnm;
   MENUP prmpt;
   long chars;
   long xpos;
   long ypos;
   long mainc;
   MENUP fname;
} MENURSTR;

typedef struct
{
   MENUP filnm;
   MENUP start;
   MENUP end;
   long chars;
   long mainc;
   long listc;
} MENUVIEW;

typedef struct
{
   MENUP name;
   long xpos;
   long ypos;
   long mainc;
} MENUBUTN;

typedef struct
{
   MENUP name;
   long xpos;
   long ypos;
   long mainc;
   long spr2;
   long opts;
   MENUP retk;
} MENUXBTN;

typedef struct
{
   MENUP mennm;
   MENUP itlst;
   MENUP stlst;
   long mictl;
   long lines;
   long colms;
   long xpos;
   long ypos;
   long mainc;
   long listc;
   MENUP retn;
} MENULIST;

typedef struct
{
   MENUP mennm;
   long avbit;
   long avbl[2];
   long font;
   long xpos;
   long ypos;
   long mainc;
   long listc;
   MENUP retst;
} MENUCHSL;

typedef struct
{
    MENUP mennm;
    MENUP actds;
    long  chars;
    long xpos;
    long ypos;
    long mainc;
    long mictl;
    void *pact;
} MENUDORP;

typedef struct
{
   long key;
   MENUP result;
} MENUINFO;

typedef struct
{
   MENUP dtyp;
   MENUP mcnt;
   MENUP bufl;
} SCRAPINFO;

typedef struct
{
   short opt;
   unsigned char pack;
   unsigned char dtyp;
   MENUP strg;
   long flln;
   void *uccd;
} SCRAPPUT;

typedef struct
{
   short opt;
   unsigned char pack;
   unsigned char dtyp;
   void *dest;
   unsigned long bufl;
   void *uccd;
} SCRAPGET;

typedef union 
{
    char txt[4];
    long x;
} ALIGN;

#define THP_UPD     0xe100
#define THP_CALL    0xc000
#define THP_RET     0xa000
#define THP_PTR     0x8000
#define THP_OPT     0x1000
#define THP_NNUL    0x0800
#define THP_ARR     0x0800
#define THP_CHAR    0x0004
#define THP_UBYT    0x0008
#define THP_SBYT    0x000a
#define THP_UWRD    0x0010
#define THP_SWRD    0x0012
#define THP_ULNG    0x0020
#define THP_SLNG    0x0022
#define THP_FP8     0x0042
#define THP_STR     0x0100
#define THP_SSTR    0x0200

#define DSEL "DSEL"
#define FSEL "FSEL"
#define XSEL "XSEL"
#define ITSL "ITSL"
#define RPER "RPER"
#define FERR "FERR"
#define RSTR "RSTR"
#define LIST "LIST"
#define VIEW "VIEW"
#define BUTN "BUTN"
#define DORP "DORP"
#define CHSL "CHSL"
#define INFO "INFO"
#define XBTN "XBTN"

#define CLR  "CLR "
#define PUT  "PUT "
#define GET  "GET "

typedef struct
{
   void *ptr;
   short ndims;
   short nitems0;
   short mult0;
   short nitems1;
   short mult1;
} ARRAYDESC;

typedef struct 
{
    MENU_CB_t func;
    void *param;
} AFUNC_t;

typedef struct 
{
    SCRAP_CB_t func;
    void *param;
} SFUNC_t;

typedef struct
{
    short jsr;
    long (*interface)(void);
    void *function;
} ACTION_t;

#ifndef JSR
# define JSR 0x4EB9
#endif

extern int  _use_qmenu(char *, void *);
extern int  _use_scrap(char *, void *);
extern long _menu_act (void);
extern long _scrap_act(void);

#endif
