* ut.x
*
*  (c) 1997 Christopher Cave and Jonathan Hudson
*  This file is part of the freely distributable menu_rext c68 library
*  It may be distributed under the same terms as c68
* 
*  Authors:
*     Christopher Cave    <ccave@cix.compulink.co.uk>
*     Jonathan Hudson     <jrhudson@bigfoot.com>
* 
*
*
* use routines for the qmenu and scrap extension things.
* (c) 30/12/1999 thierry godefroy.
*
* int _use_qmenu(char *extension, void *parameter_list);
* int _use_scrap(char *extension, void *parameter_list);
*
* note: the extension name must be 4 characters long (pad it with spaces if
*       it is three charcaters long or less).
	
        .globl	__use_scrap
	.globl	__use_qmenu
	.globl LIBQMENU_VER
.text
.even

*          comment   c68 libqmenu_a v1.05

__use_scrap:
        lea	scrap,a0                      ; thing name.
        bra	useqmenu1                     ;call this thing.
__use_qmenu:
        lea	qmenu,a0                      ;thing name.
useqmenu1: 
	movem.l	d3-d7/a2-a6,-(sp)             ;save the context.
	move.l  a0,d7                         ;save the ptr on thing name.
        lea     44(sp),a5                     ;pointer on parameters.
        movea.l (a5)+,a1                      ;pointer on extension name.
        moveq   #3,d0                         ;dbra counter (4 chars).
useqmenu2:
	lsl.l   #8,d2                         ;room for next character.
        move.b  (a1)+,d2                      ;get a character.
        dbra    d0,useqmenu2                  ;next character.
        bsr	use_thing                     ;use the thing.
        bne     useqmenu3                     ;if error, return now.
        lea     $18(a1),a4                    ;vector for the extension.
        movea.l (a5),a1                       ;pointer on the parameter list.
        jsr     (a4)                          ;call the extension.
        move.l  d0,d4                         ;save the error code.
        movea.l d7,a0                         ;get back ptr on thing name.
        bsr     free_thg                      ;free the thing.
        move.l  d4,d0                         ;restore the error code
useqmenu3:
	movem.l (sp)+,d3-d7/a2-a6             ;restore the context.
        rts                                   ;return.

qmenu:  
	dc.w	5
	dc.b    'menus',0

scrap:
	dc.w	16
        dc.b    'scrap extensions'

********************************************************************************
* routines d'utilisation et de libration d'une chose:
* ===================================================
*
* paramtres en entre: d0.l = $28 ou $29 (si appel de do_thing),
* ~~~~~~~~~~~~~~~~~~~~  d1.l = id du job concern (si appel de use_thg),
*                       d2.l = paramtre supplmentaire ventuel (selon chose),
*                       d3.l = paramtre supplmentaire ventuel (si free_thg),
*                       a0.l = pointeur sur le nom de la chose,
*                       a1.l = paramtre supplmentaire ventuel (free_thg),
*                       a2.l = paramtre supplmentaire ventuel (selon chose),
*
* paramtres en sortie: d0.l = code d'erreur,
* ~~~~~~~~~~~~~~~~~~~~  d1.l = id du job concern (ou -1 si appel de free_thg),
*                       d2.l = rsultat (selon la chose),
*                       d3.l = version de la chose (si sms.uthg) ou prserv,
*                       d4.l  d7.l: prservs,
*                       a1.l = pointeur sur la chose (si sms.uthg) ou prserv,
*                       a2.l = ptr/bloc chanage chose (si sms.uthg) ou rsultat
*                       a0.l, a3.l  a7.l: prservs.

free_thg:
	moveq	#-1,d1                        ;job utilisateur=job courant.
        moveq   #$29,d0                       ;code pour appel  sms.fthg.
        bra     do_thg

use_thing:
	moveq   #-1,d1                        ;job utilisateur=job courant.
use_thg:
	moveq   #$28,d0                       ;code pour appel  sms.uthg.
do_thing:  
	moveq	#-1,d3                        ;temporisation infinie.
do_thg:
	move.l	a4,-(sp)                      ;| sauvegarder le contexte.
	movem.l d0/a0,-(sp)                   ;|
        bsr     search                        ;chercher le vecteur "thing".
        movem.l (sp)+,d0/a0                   ;restaurer ptr nom est code.
        bne     done1                         ;si erreur pas d'appel.
        jsr     (a4)                          ;appel au vecteur "thing".
done1:  movea.l (sp)+,a4                      ;restaurer contexte.
        cmpi.l  #-7,d0                        ;erreur "not found" ?
        bne     done2                         ;si non, sauter ce qui suit...
        moveq   #-19,d0                       ;code erreur "not implemented".
done2:  tst.l   d0                            ;positionner ccr.
        rts                                   ;retour.

********************************************************************************
* routine de recherche de la chose "thing":
* ========================================
*
* paramtres en entre: nant
* ~~~~~~~~~~~~~~~~~~~~
* paramtres en sortie: a0.l=adresse de "thing" (si d0=0),
* ~~~~~~~~~~~~~~~~~~~~  a4.l=adresse de la routine "th_entry",
*                       d0.l=code erreur (0: pas d'erreur, -19: non implment),
*
* registres modifis  : d0, a0, a4.
* ~~~~~~~~~~~~~~~~~~

search: 
	movem.l d1/d2,-(sp)                   ;sauver le contexte.
        moveq   #0,d0                         ;| prendre les informations
        trap    #1                            ;| sur le systme.
        moveq   #-19,d0                       ;code erreur "non implment".
        lea     $b8(a0),a0                    ;pointeur sur liste des choses.
        move.l  a0,d1                         ;pointeur nul ?
        beq     search3                       ;si oui, retour (pas de chose).
search1:
	move.l  (a0),d1                       ;d1=adresse du linkage block.
        beq     search2                       ;si dernire chose, fin
        movea.l d1,a0                         ;| sinon poursuivre la recher-
        bra     search1                       ;| che avec la chose suivante.
search2:
	movea.l 16(a0),a0                     ;pointeur sur chose elle-mme.
	cmpi.l  #$54484725,(a0)                  ;est-ce bien une chose ?
        bne     search3                       ;si non, retour avec erreur.
        cmpi.l  #-1,4(a0)                     ;est-ce la chose "thing" ?
        bne     search3                       ;si non, retour avec erreur.
        movea.l 8(a0),a4                      ;prendre le vecteur th_entry.
        moveq   #0,d0                         ;pas d'erreur.
search3:
	movem.l (sp)+,d1/d2                   ;restaurer le contexte.
        tst.l   d0                            ;positionner ccr.
        rts                                     ;retour.
LIBQMENU_VER:
	dc.b    "$Id: libqmenu " 
        dc.b    VERSION
	dc.b    " $"
        ds.w    0
.end
